// Created by Nullable(DontCare4Free)
// Revised and commented by McTwist

exec("./filters.cs");

// Temporary variable
// Separate each punctuation with a space
$MedievalChatFilter::Punctuation = "! ? ' . , ; : - _ * ^ \" # $ & ( ) = + %   { [ ] } < > ~";

// RTB variables
if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if (!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Ignored prefixes (SA)", "Medieval Chat", "MedievalChatFilter::IgnoredSA", "string 60", "Script_MedievalChatFilter", "$", 0, 0);
	RTB_registerPref("Enabled", "Medieval Chat", "MedievalChatFilter::Enabled", "bool", "Script_MedievalChatFilter", true, 0, 0);
	RTB_registerPref("Enabled (team chat)", "Medieval Chat", "MedievalChatFilter::TeamChatEnabled", "bool", "Script_MedievalChatFilter", true, 0, 0);
}
else
{
	$MedievalChatFilter::IgnoredSA = "$";
	$MedievalChatFilter::Enabled = true;
	$MedievalChatFilter::TeamChatEnabled = true;
}

// Go throguh a string and return a modified one
function medievalChatReplace(%msg)
{
	// Will it prefix?
	if (mCeil(getRandom() * 10) <= 4)
	{
		%msg = $MedievalChatFilter::Prefix[mFloor(getRandom() * $MedievalChatFilter::PrefixCount)] SPC %msg;
	}

	// Will it suffix?
	if (mCeil(getRandom() * 10) <= 4)
	{
		%msg = %msg SPC $MedievalChatFilter::Suffix[mFloor(getRandom() * $MedievalChatFilter::SuffixCount)];
	}

	// Giving knowledge about adjectives
	while(strPos(%msg, "<adj>") != -1)
	{
		%pos = strPos(%msg, "<adj>");
		%len = 5;
		%msg = getSubStr(%msg, 0, %pos) @ $MedievalChatFilter::Adjective[mFloor(getRandom() * $MedievalChatFilter::AdjectiveCount)] @ getSubStr(%msg, %pos + %len, strLen(%msg));
	}

	%oldeMsg = "";

	%count = getWordCount(%msg);
	// Run through every word
	for (%i = 0; %i < %count; %i++)
	{
		%word = getWord(%msg, %i);
		%wordLength = strlen(%word);
		%punctuation = "";
		
		%doPunc = false;
		%puncLen = 1;
		%puncLength = getWordCount($MedievalChatFilter::Punctuation);
		// Go through some punctuation
		for (%n = 0; %n < %puncLength; %n++)
		{
			// Locate punctuation
			%puncPos = strPos(%word, getWord($MedievalChatFilter::Punctuation, %n));
			if (%puncPos != -1)
			{
				// Remove punctuation and return
				%puncLen = %wordLength - %puncPos;
				%puncPos = -1;
				%doPunc = true;
				%punctuation = getWord($MedievalChatFilter::Punctuation, %n);
				%word = getSubStr(%word, 0, %wordLength - %puncLen);
				break;
			}
		}

		// Locate modern phrase
		%modernId = $MedievalChatFilter::Modern[%word];
		if (%modernId !$= "")
		{
			%upper = true;
			if (strPos(strUpr(getSubStr(%word, 0, 1)), getSubStr(%word, 0, 1)))
				%upper = false;
			%oldeCount = $MedievalChatFilter::YeOlde[%modernId, count];
			%word = $MedievalChatFilter::YeOlde[%modernId, mClamp(mFloor(getRandom() * %oldeCount), 0, %oldeCount)];
			if (%upper)
				%word = strUpr(getSubStr(%word, 0, 1)) @ strLwr(getSubStr(%word, 1, strLen(%word)));
			else
				%word = strLwr(%word);
		}
		%oldeMsg = %oldeMsg SPC %word @ %punctuation;
	}

	return %oldeMsg;
}

// Package
package medievalChat
{
	function serverCmdMessageSent(%cl, %msg)
	{
		if ($MedievalChatFilter::Enabled && !(%cl.isSuperAdmin && strPos($MedievalChatFilter::IgnoredSA, getSubStr(%msg, 0, 1)) != -1))
			%msg = medievalChatReplace(%msg);
		parent::serverCmdMessageSent(%cl, %msg);
	}

	function serverCmdTeamMessageSent(%cl, %msg)
	{
		if ($MedievalChatFilter::TeamChatEnabled)
			%msg = medievalChatReplace(%msg);
		parent::serverCmdTeamMessageSent(%cl, %msg);
	}
};
activatePackage(medievalChat);
